namespace Fetch
{
    using System.Drawing;
    using System.Linq;
    using Levelbot.Actions.Combat;
    using Styx.Pathing;
    using System;
    using Styx.Helpers;
    using System.Threading;
    using System.Diagnostics;
    using Styx.WoWInternals;
    using Styx.WoWInternals.WoWObjects;
    using System.Collections.Generic;
    using System.Linq.Expressions;
    using System.IO;
    using System.Runtime.InteropServices;
    using System.Xml.Linq;
    using System.Net;
    using Styx;
    using Styx.Plugins;
    using Styx.Common;
    using Styx.CommonBot;
    using Styx.CommonBot.Frames;
	using System.Windows.Media;
    
    public class Fetch : HBPlugin
    {
        //Normal Stuff.
        public override string Name { get { return "Fetch"; } }
        public override string Author { get { return "WarHopper/BadWolf/Inrego"; } }
        public override Version Version { get { return new Version(1, 0); } }
        public override bool WantButton { get { return true; } }
        public override string ButtonText { get { return "None"; } }

        //Logging Class
        public static void slog(string format, params object[] args)
        {
            Logging.Write(Colors.ForestGreen, "[Fetch]: " + format, args);
        }
        private static readonly LocalPlayer Me = StyxWoW.Me;
        private double LootRange
        {
            get { return LootTargeting.LootRadius; }
        }
        private IOrderedEnumerable<WoWUnit> Lootables
        {
            get
            {
                var targetsList = ObjectManager.GetObjectsOfType<WoWUnit>(false, false).Where(
                        p => (p.Lootable || p.CanSkin) && p.Distance <= LootRange).OrderBy(l => l.Distance);
                return targetsList;
            }
        }

        public override void Initialize()
        {
            Logging.Write(Colors.Lime, "+ " + Name + ", " + Version + ", enabled mods:");

            Logging.Write(Colors.Yellow, "creating Timers...");
            Timers.Add("Fetch");
            Logging.Write(Colors.Yellow, "done!");
        }
        public override void Pulse()
        {
            if (Me.Combat || !SpellManager.HasSpell("Fetch") || Me.IsCasting || Lootables.Count() == 0 || Me.IsMoving)
                return;
            if (LootFrame.Instance != null && LootFrame.Instance.IsVisible)
            {
                LootFrame.Instance.LootAll();
                return;
            }
            var lootTarget = Lootables.FirstOrDefault();
            if (lootTarget.Distance < 50 && (Timers.Expired("Fetch", 4000)))
            {
                slog("Fetching loot {0}.", lootTarget.Name);
                lootTarget.Target();
                Lua.DoString("RunMacroText(\"/use Fetch\")");
                // /use [@target,exists,dead] Fetch\n/targetlasttarget\n/use [@target,exists,dead] Fetch

                if (!Timers.Exists("Fetch"))
                    Timers.Add("Fetch");
                else
                    Timers.Reset("Fetch");

            }
            else
            {
                return;
            }
        }
    }
}

